;#SECTION "MAIN", CODE

	org	userMem - 2
	db	0BBh, 6Dh
Start:
	xor	a
	jr	nc, @F
	db	"Camera Timer", 0
@:
	in	a, (2)
	or	a
	jp	m, @F
	ld	hl, modelErr
	B_CALL	_PutS
	B_CALL	_NewLine
	ret

@:
	pop	hl
	ld	(quitAddr), hl
	res	indicRun, (iy + shiftFlags)
	res	donePrgm, (iy + kbdFlags)
; This flag performs magic.
	res	5, (iy + 44h)
	B_CALL	_ClrScrn
	res	appTextSave, (iy + appFlags)
	ld	(iy + runFlags), 0
	ld	(iy + settings), 0
	ld	a, (intsCheckSum)
	ld	c, a
	ld	hl, countT
	ld	b, intsLen
	call	CheckSum
	cp	c
	call	nz, LoadDefaults
;
	ld	(mainStack), sp
MainMenu:
	ld	a, 1
	out	(10h), a
	dec	a
	out	(20h), a
	im	1
	ld	sp, (mainStack)
	call	waitForScreen
	ld	a, 40h
	out	(10h), a
	B_CALL	_ClrLCDFull
subret:
	ld	hl, menuMain
	jq	Menu

Quit:
	call	killISR
	ld	a, 1
	out	(10h), a
; BCALL _FillBasePageTable
	ei
; Flush key buffer
	nop
	halt
	B_CALL	_GetCSC
	halt
	B_CALL	_GetCSC
	B_CALL	_ClrScrnFull
	B_CALL	_HomeUp
	res	onInterrupt, (iy + onFlags)
; The OS takes care of the
; stack via an error handler.
	ld	sp, (mainStack)
	ld	hl, (quitAddr)
	jp	(hl)

;#SECTION "PTSISR", DATA

ISRLoc equ	81h
ISRTable equ	99h
ISR:
	ex	af, af'
	in	a, (4)
	bit	5, a
	jq	nz, ISRT1
	bit	6, a
	jq	nz, ISRT2
	bit	7, a
	jq	nz, ISRT3
	bit	0, a
	jq	nz, ISROn
	bit	1, a
	jq	nz, incTime
ISRAckAll:
	xor	a
	out	(3), a
	ld	a, intMask
	out	(3), a
ISREnd:
	ex	af, af'
	ei
	ret

ISRT1:
; LD   A,tmrLoopVal
	xor	a
	out	(31h), a
incTime:
	exx
	bit	paused, (iy + settings)
	jr	nz, @F
	ld	a, 0FFh
	ld	hl, timeToggle
	xor	(hl)
	ld	(hl), a
	jr	nz, @F
	bit	doLoopActive, (iy + runFlags)
	jr	z, dls
	ld	hl, (deadlinesMissed)
	inc	hl
	ld	(deadlinesMissed), hl
	pop	hl
	push	hl
	ld	(deadlineAddr), hl
dls:
	ld	hl, masterTime
	inc	(hl)
	jr	nz, @F
	inc	hl
	inc	(hl)
	jr	nz, @F
	inc	hl
	inc	(hl)
	jr	nz, @F
	inc	hl
	inc	(hl)
@:
	exx
	ld	a, (lastKeyDelay)
	or	a
	jq	z, ISRAckAll
	dec	a
	ld	(lastKeyDelay), a
	jq	nz, ISREnd
	ld	(lastKey), a
	jq	ISRAckAll

ISRT2:
	xor	a
	out	(34h), a
	out	(33h), a
	jq	ISREnd

ISRT3:
	xor	a
	out	(35h), a
	out	(37h), a
	out	(36h), a
	jq	ISREnd

activateISR:
	res	doLoopActive, (iy + runFlags)
	call	loadISR
	di
	ld	a, ISRTable
	ld	i, a
	ld	a, 00000000b
	out	(4), a
	ld	a, intMask
	out	(3), a
	xor	a
; LD   A,tmrFreq
	out	(30h), a
; LD   A,tmrLoopVal
	out	(31h), a
; LD   A,tmrCount
	out	(32h), a
; XOR  A
	out	(33h), a
	out	(34h), a
	out	(35h), a
	out	(36h), a
	im	2
	ei
	ret

killISR:
	ld	a, 00001011b
	out	(3), a
	ld	a, 00000110b
	out	(4), a
	xor	a
	out	(0), a
	im	1
	ei
	ret

loadISR:
	ld	hl, ISRTable * 0100h
	ld	a, ISRLoc
	ld	b, 0
loadISRTableLoop:
	ld	(hl), a
	inc	hl
	djnz	loadISRTableLoop
	ld	(hl), a
	inc	hl
	ld	(hl), a
; now load ISR
	ld	hl, ISRStub
	ld	de, ISRLoc * 0100h + ISRLoc
	ld	bc, ISRStubEnd - ISRStub
	ldir
	ret

; limited space in ISR
ISRStub:
	jp	ISR

ISRStubEnd:
ISROn:
	jp	Quit

;#SECTION "PTSMain", CODE

PTPaused:
	set	paused, (iy + settings)
	jr	@F

PTSMain:
	res	paused, (iy + settings)
@:
	res	doLoopActive, (iy + runFlags)
	ld	hl, time0
	ld	de, masterTime
	call	CopyTime
	ld	a, 1
	out	(20h), a
	B_CALL	_ClrLCDFull
	xor	a
	ld	(timeToggle), a
	call	activateISR
	jq	PTInit

; See section PTInit
PTInitCont:
	xor	a
	ld	(curRow), a
	ld	(zIndex), a
	ld	(lastKey), a
	ld	(lastKeyDelay), a
	ld	(screenCycle), a
; LD   (eventFireCount),A
; LD   (eventFireCount+1),A
	ld	(deadlinesMissed), a
	ld	(deadlinesMissed + 1), a
PTSLoop:
	res	doLoopActive, (iy + runFlags)
@:
	halt
	ld	a, (timeToggle)
	or	a
	jr	nz, @B
	set	doLoopActive, (iy + runFlags)
	call	GetCloneSC
	cp	skClear
	jq	z, PTSEnd
	cp	skZoom
	push	af
	call	z, doManExpLock
	pop	af
	cp	sk2nd
	call	z, PTPause
	cp	skAlpha
	call	z, PTUnpause
	cp	skTrace
	jq	z, rstFocus
	cp	skGraph
	jq	z, rstExpose
	ld	a, 0BFh
	ld	c, 00010000b
	call	DirectInput
	push	af
	call	nz, doManFocus
	pop	af
	call	z, noManFocus
	ld	a, 0BFh
	ld	c, 00001000b
	call	DirectInput
	push	af
	call	nz, doManExp
	pop	af
	call	z, noManExp
	bit	paused, (iy + settings)
	jq	nz, PTNoScan
	ld	de, eventList
; LD   DE,eventList+8
	ld	b, maxEvents
; LD   B,maxEvents-2
PTScanLoop:
	ld	hl, masterTime
	call	compTime
	jr	c, PTLoopNEQ
	push	de
	push	bc
	ld	hl, PTContScan
	push	hl
; C for A<   or   HL< DE
	inc	de
	inc	de
	inc	de
	inc	de
	ld	a, (de)
	ld	l, a
	inc	de
	ld	a, (de)
	or	a
	jq	z, PTContScan
	ld	h, a
	jp	(hl)

PTContScan:
	pop	bc
	pop	de
PTLoopNEQ:
	ld	a, e
	add	a, 6
	ld	e, a
	jr	nc, $ + 3
	inc	d
	djnz	PTScanLoop
PTNoScan:
	call	DoScreen
	jq	PTSLoop

PTSEnd:
	call	killISR
; Flush key buffer
	halt
	B_CALL	_GetCSC
	halt
	B_CALL	_GetCSC
	jq	MainMenu

DoScreen:
	ld	de, OP5
	call	Clr16
	ld	hl, screenCycle
	ld	a, (hl)
	ld	(curRow), a
	inc	(hl)
	cp	7
	jq	z, ds7
	cp	6
	jq	z, ds6
; CP   5
; JQ   Z,ds5
; CP   4
; JQ   Z,ds4
	cp	3
	jq	z, ds3
	cp	2
	jq	z, ds2
	cp	1
	jq	z, ds1
	or	a
	ret	nz
ds0:
	ld	de, OP5
	call	Clr16
	ld	hl, strTime
	ld	de, OP5
	call	StrCopy
	ld	ix, masterTime
	call	TimeStr
; CALL TimeStrShort
	ld	ix, OP5
	call	DispLine
	ret

ds7:
	ld	de, OP5
	ld	a, (focusCount)
	or	a
	ld	a, 2
	jr	z, @F
	dec	a
@:
	ld	(de), a
	inc	de
	ld	hl, strFocus
	call	StrCopy
	ld	a, (exposeCount)
	or	a
	ld	a, 2
	jr	z, @F
	dec	a
@:
	ld	(de), a
	inc	de
	ld	hl, strExpose
	call	StrCopy
	ld	ix, OP5
	call	DispLine
	ld	hl, screenCycle
	ld	(hl), 0
	ret

ds1:
	ld	hl, strNext
	ld	de, OP5
	call	StrCopy
	ld	de, OP1
	ld	hl, evExpStart
	call	CopyTime
	ld	de, masterTime
	ld	hl, OP1
	call	SubTime
	ld	de, OP5 + 6
	ld	ix, OP1
	call	TimeStr
; CALL TimeStrShort
	ld	ix, OP5
	jq	DispLine

ds3:
	ld	hl, strExpRemain
	ld	de, OP5
	call	StrCopy
	ld	hl, (expRemaining)
	call	Num2Dec
	ld	ix, OP5
	jq	DispLine

ds2:
	ld	a, (exposeCount)
	or	a
	jq	z, @F
	bit	paused, (iy + settings)
	jq	nz, @F
	ld	hl, strExp
	ld	de, OP5
	call	StrCopy
	push	de
	ld	hl, masterTime
	ld	de, OP1
	call	CopyTime
	ld	hl, OP1
	ld	de, expStartTime
	call	SubTime
	pop	de
	ld	ix, OP1
	call	TimeStr
; CALL TimeStrShort
@:
	ld	ix, OP5
	jq	DispLine

; ds4:
; ds5:
; RET
ds6:
	ld	hl, (deadlinesMissed)
	ld	a, l
	or	h
	ret	z
	ld	de, OP5
	push	hl
	ld	hl, strDeadlineMissed
	call	StrCopy
	pop	hl
	call	Num2Dec
	inc	de
	ld	hl, (deadlineAddr)
	call	Num2Hex
	ld	ix, OP5
	jq	DispLine

;#SECTION "PTInit", CODE

rstFocus:
	ld	hl, prefocusInt
	ld	de, delayInt
	call	CopyTime
	jr	@F

rstExpose:
	ld	hl, time0
	ld	de, delayInt
	call	CopyTime
@:
	set	paused, (iy + settings)
	ld	hl, time0
	ld	de, masterTime
	call	CopyTime
	res	paused, (iy + settings)
PTInit:
; RES  KADisable,(IY+runFlags)
; RES  manExp,(IY+runFlags)
; RES  manExpLock,(IY+runFlags)
; RES  manFocus,(IY+runFlags)
	xor	a
	ld	(iy + runFlags), a
	ld	(exposeCount), a
	ld	(focusCount), a
; LD   (timeToggle),A
	call	updateLink
	ld	hl, (count)
	ld	(expRemaining), hl
; Load vectors
	ld	hl, evTableDefaults
	ld	de, eventList
	ld	bc, evTableDefaultLen
	ldir
; Exposure, delay
	ld	hl, (expRemaining)
	ld	a, l
	or	h
	ld	hl, delayInt
	jq	nz, @F
	ld	hl, timeBig
@:
	ld	de, evExpStart
	call	CopyTime
	ld	hl, evExpStart
	ld	de, evExpStop
	call	CopyTime
	ld	hl, evExpStop
	ld	de, exposureInt
	call	AddTime
; PF
	ld	hl, prefocusInt
	call	IsTimeZero
	ld	hl, evExpStart
	jr	nz, @F
	ld	hl, timeNever
@:
	ld	de, evFCStart
	call	CopyTime
	ld	hl, evFCStart
	ld	de, prefocusInt
	call	SubTime
; Does prefocus start before
; the exposure?
	jr	nc, @F
	ld	hl, evFCStart
	ld	de, intervalInt
	call	AddTime
@:
	ld	hl, evFCStart
	ld	de, evFCStop
	call	CopyTime
	ld	hl, evFCStop
	ld	de, pfDurationInt
	call	AddTime
; Keep-alive
	ld	hl, keepAliveInt
	push	hl
	call	IsTimeZero
	pop	hl
	jr	nz, @F
	ld	hl, timeNever
@:
	ld	de, evKAStart
	push	de
	call	CopyTime
	pop	hl
	ld	de, evKAStop
	push	de
	call	CopyTime
	pop	hl
	ld	de, KAInt
	call	AddTime
	jq	PTInitCont

;#SECTION "PTEvent", CODE

; incEVCount:
; PUSH HL
; LD   HL,(eventFireCount)
; INC  HL
; LD   (eventFireCount),HL
; POP  HL
; RET
PTExpStart:
	bit	paused, (iy + settings)
	ret	nz
	call	startExpose
	set	KADisable, (iy + runFlags)
	ld	hl, evExpStart
finishEvent:
; CALL incEVCount
	ld	de, intervalInt
	jq	AddTime

PTExpStop:
	call	stopExpose
	res	KADisable, (iy + runFlags)
	ld	hl, (expRemaining)
	dec	hl
	ld	a, l
	or	h
	ld	(expRemaining), hl
	jq	z, PTDone
	ld	hl, evExpStop
	jq	finishEvent

PTFCStart:
	call	startFocus
	set	KADisable, (iy + runFlags)
	ld	hl, evFCStart
	jq	finishEvent

PTFCStop:
	call	stopFocus
	ld	hl, (expRemaining)
	ld	a, l
	or	h
	ld	hl, evFCStop
	jq	nz, finishEvent
	ld	hl, timeBig
	ld	de, evFCStop
	jq	CopyTime

PTKAStart:
	bit	KADisable, (iy + runFlags)
	call	z, startFocus
@:
	ld	hl, evKAStop
	ld	de, keepAliveInt
	bit	KADisable, (iy + runFlags)
	call	nz, AddTime
	ld	hl, evKAStart
	ld	de, keepAliveInt
	jq	AddTime

PTKAStop:
	call	stopFocus
	ld	hl, evKAStop
	ld	de, keepAliveInt
	jq	AddTime

PTPause:
	set	paused, (iy + settings)
; CALL incEVCount
	ret

PTUnpause:
	res	paused, (iy + settings)
; CALL incEVCount
	ret

PTDone:
	bit	autoQuit, (iy + settings)
	jq	z, @F
	ld	a, (exposeCount)
	or	a
	jq	nz, @F
	ld	a, (focusCount)
	or	a
	jq	nz, @F
	pop	hl
	bit	quitWhenDone, (iy + settings)
	jq	z, PTSEnd
	call	killISR
	B_CALL	_ClrScrnFull
	B_CALL	_HomeUp
; LD   HL,strDone
; CALL PutS
	jq	Quit

@:
	ld	hl, timeBig
	ld	de, evExpStart
	push	hl
	call	CopyTime
	pop	hl
	ld	de, evExpStop
	push	hl
	call	CopyTime
	pop	hl
	ld	de, evFCStart
	jq	CopyTime

;#SECTION "LinkCode", CODE

doManExpLock:
	bit	manExpLock, (iy + runFlags)
	jr	nz, @F
	set	manExpLock, (iy + runFlags)
	jq	startExpose

@:
	res	manExpLock, (iy + runFlags)
	jq	stopExpose

doManFocus:
	bit	manFocus, (iy + runFlags)
	ret	nz
	set	manFocus, (iy + runFlags)
startFocus:
	ld	a, (focusCount)
	inc	a
	ld	(focusCount), a
	jr	updateLink

noManFocus:
	bit	manFocus, (iy + runFlags)
	ret	z
	res	manFocus, (iy + runFlags)
stopFocus:
	ld	a, (focusCount)
	or	a
	jr	z, updateLink
	dec	a
	ld	(focusCount), a
	jr	updateLink

doManExp:
	bit	manExp, (iy + runFlags)
	ret	nz
	set	manExp, (iy + runFlags)
startExpose:
	ld	a, (exposeCount)
	or	a
	jr	nz, @F
	ld	hl, masterTime
	ld	de, expStartTime
	call	CopyTime
@:
	inc	a
	ld	(exposeCount), a
	jr	updateLink

noManExp:
	bit	manExp, (iy + runFlags)
	ret	z
	res	manExp, (iy + runFlags)
stopExpose:
	ld	a, (exposeCount)
	or	a
	jr	z, updateLink
	dec	a
	ld	(exposeCount), a
updateLink:
	ld	b, 0
	ld	a, (focusCount)
	or	a
	jr	z, @F
	inc	b
@:
	ld	a, (exposeCount)
	or	a
	jr	z, @F
	ld	a, 1
@:
	bit	linkRev, (iy + settings)
	jr	z, linkNotRev
	add	a, a
	or	b
	jr	@F

linkNotRev:
	sla	b
	or	b
@:
	ld	b, a
	xor	a
	bit	linkInv, (iy + settings)
	jq	z, @F
	ld	a, 3
@:
	xor	b
	out	(0), a
	ret

;#SECTION "FontCode", CODE

DispLine:
; in: ix
	xor	a
	out	(10h), a
	res	inverseText, (iy + runFlags)
	ld	a, (curRow)
	add	a, a
	add	a, a
	add	a, a
	add	a, 80h
	ld	(iy + fontWriteRow), a
	ld	a, 7
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
	call	waitForScreen
	out	(10h), a
	ld	hl, fontData
	ld	(fontDataLoc), hl
	ld	c, 8
dispLineMasterLoop:
	ld	a, (iy + fontWriteRow)
; PUSH IX
; PUSH IX
; PUSH IX
; PUSH IX
; PUSH IX
; POP  IX
; POP  IX
; POP  IX
; POP  IX
; POP  IX
	call	waitForScreen
	out	(10h), a
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
	push	ix
	ld	b, 16
	ld	a, 20h
	call	waitForScreen
	out	(10h), a
dispLineLoop:
	ld	h, 0
	ld	a, (ix + 0)
	cp	chInverse
	jr	nz, @F
	xor	a
	set	inverseText, (iy + runFlags)
@:
	cp	chNormal
	jr	nz, @F
	xor	a
	res	inverseText, (iy + runFlags)
@:
	or	a
	jq	z, @F
	sub	firstChar
@:
	ld	l, a
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, (fontDataLoc)
	add	hl, de
	ld	a, (hl)
	bit	inverseText, (iy + runFlags)
	jr	z, @F
	cpl
	sub	0C0h
@:
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
	call	waitForScreen
	out	(11h), a
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
; PUSH IX
; POP  IX
	inc	ix
	djnz	dispLineLoop
	pop	ix
	ld	hl, (fontDataLoc)
	inc	hl
	ld	(fontDataLoc), hl
	inc	(iy + fontWriteRow)
	dec	c
	jq	nz, dispLineMasterLoop
	ret

NextLine:
	ld	a, (zIndex)
	srl	a
	srl	a
	srl	a
	dec	a
	and	7
	ld	b, a
	ld	a, (curRow)
	cp	b
	jq	nz, .nextlnorot
	ld	a, (zIndex)
	add	a, 8
	cp	40h
	jq	nz, @F
	xor	a
@:
	ld	(zIndex), a
	add	a, 40h
	out	(10h), a
.nextlnorot:
	ld	a, (curRow)
	inc	a
	cp	8
	jq	nz, @F
	xor	a
@:
	ld	(curRow), a
; erase next line
	ret

Clr16:
	ld	b, 16
	xor	a
	push	de
@:
	ld	(de), a
	inc	de
	djnz	@B
	pop	de
	ret

waitForScreen:
	push	af
@:
	in	a, (10h)
	and	80h
	jr	nz, @B
	pop	af
	ret

;#SECTION "Equates", DATA

firstChar equ	20h
chInverse equ	1
chNormal equ	2
fontWriteRow equ	asm_Flag2
runFlags equ	xapFlag1
doLoopActive equ	2
KADisable equ	3
inverseText equ	4
manFocus equ	5
manExp equ	6
manExpLock equ	7
settings equ	asm_Flag1
paused equ	0
linkInv equ	1
linkInvMask equ	2
linkRev equ	2
linkRevMask equ	4
autoQuit equ	3
autoQuitMask equ	8
quitWhenDone equ	4
quitWhenDoneMask equ	16
; RAM areas
; timerRAM = appBackUpScreen
timerRAM equ	8000h
quitAddr equ	timerRAM
mainStack equ	quitAddr + 2
zIndex equ	mainStack + 2
fontDataLoc equ	zIndex + 1
lastKey equ	fontDataLoc + 2
lastKeyDelay equ	lastKey + 1
; Settings
intsCheckSum equ	lastKeyDelay + 4
intsLen equ	7 * 4
count equ	intsCheckSum + 4
countT equ	count - 1
intervals equ	delayInt
delayInt equ	count + 3
intervalInt equ	delayInt + 4
exposureInt equ	intervalInt + 4
prefocusInt equ	exposureInt + 4
pfDurationInt equ	prefocusInt + 4
keepAliveInt equ	pfDurationInt + 4
endInts equ	keepAliveInt + 4
eventList equ	endInts + 16
runLocals equ	eventList
maxEvents equ	6
evKAStart equ	eventList
evKAStop equ	evKAStart + 6
evFCStart equ	evKAStop + 6
evFCStop equ	evFCStart + 6
evExpStart equ	evFCStop + 6
evExpStop equ	evExpStart + 6
expStartTime equ	evExpStop + 10
masterTime equ	expStartTime + 4
focusCount equ	masterTime + 4
exposeCount equ	focusCount + 1
screenCycle equ	exposeCount + 1
timeToggle equ	screenCycle + 1
expRemaining equ	timeToggle + 1
eventFireCount equ	expRemaining + 2
deadlinesMissed equ	eventFireCount
deadlineAddr equ	deadlinesMissed + 2
; settingsRAM = eventList+2
; interrupt settings
intMask equ	00001011b
; timer values
tmrLoopVal equ	1
tmrFreq equ	45h
tmrCount equ	8
modelErr:
	db	"A TI-83+SE or TI-84+/SE is required.", 0
; updateMask = %11100000
keyDelay equ	10
fontData:
	incbin	"PTFONT"
;#SECTION "TimeMath", CODE

AddTime:
; input:
; -HL: arg1 & dest
; -DE: arg2
	ld	b, 4
	or	a
addLoop:
	ld	a, (de)
	adc	a, (hl)
	ld	(hl), a
	inc	hl
	inc	de
	djnz	addLoop
	ret

	ifdef	NEVER
TimeStrShort:
; ix: time
; de: dest
	ld	l, (ix + 1)
	ld	h, (ix + 2)
	call	Num2Dec
; LD   A,'.'
; LD   (DE),A
; INC  DE
	push	de
	ld	e, (ix + 0)
	ld	h, 125
	call	MultHByE
	ld	b, 5
@:
	srl	h
	rr	l
	djnz	@B
	add	hl, hl
	ld	e, l
	ld	d, h
	add	hl, de
	add	hl, de
	add	hl, de
	add	hl, de
	ld	de, OP1
	pop	de
	push	de
	call	Num2Dec
	pop	hl
	ld	(hl), '.'
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	(hl), 0
; LD   HL,OP1+2
; LD   BC,3
; LDIR
	ex	de, hl
	ret

	endif
;#SECTION "TimeStr", CODE

TimeStr:
; Inputs:
; IX: Time
; DE: Dest
	push	ix
	push	de
	ld	l, (ix + 1)
	ld	h, (ix + 2)
	ld	e, (ix + 3)
	pop	ix
	call	Str24
	push	ix
	pop	de
	pop	ix
; Dec
	push	de
	ld	e, (ix + 0)
	ld	h, 125
	call	MultHByE
	ld	b, 5
@:
	srl	h
	rr	l
	djnz	@B
	add	hl, hl
	ld	e, l
	ld	d, h
	add	hl, de
	add	hl, de
	add	hl, de
	add	hl, de
	ld	de, OP1
	pop	de
	push	de
	call	Num2Dec
	pop	hl
	ld	(hl), '.'
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	xor	a
	ld	(hl), a
	inc	hl
	ld	(hl), a
	dec	hl
	ex	de, hl
	ret

;#SECTION "SubTime2", CODE

SubTime:
; (HL)=(HL)-(DE)
; Inputs: (HL),(DE)
; Output: (HL)
	ld	b, 4
	or	a
@:
	ld	a, (de)
	ld	c, a
	ld	a, (hl)
	sbc	a, c
	ld	(hl), a
	inc	de
	inc	hl
	djnz	@B
	ret

;#SECTION "CompTime", CODE

compTime:
	push	hl
	push	de
	push	bc
	ld	b, 4
	or	a
@:
	ld	a, (de)
	ld	c, a
	ld	a, (hl)
	sbc	a, c
	inc	de
	inc	hl
	djnz	@B
	pop	bc
	pop	de
	pop	hl
	ret

IsTimeZero:
	xor	a
	ld	b, 4
@:
	or	(hl)
	ret	nz
	inc	hl
	djnz	@B
	xor	a
	ret

IsNegOrNever:
	ld	a, (hl)
	cp	0FFh
	ret	z
	cp	0FEh
	ret

;#SECTION "MoreTime", CODE

CopyTime:
	push	hl
	push	de
	push	bc
	ld	bc, 4
	ldir
	pop	bc
	pop	de
	pop	hl
	ret

;#SECTION "Menus", DATA

	db	0
menuMain:
	db	"Long Exposure & "
	db	"Time-Lapse Timer"
	db	"1. Configure"
	db	chNewLine
	db	"2. Run"
	db	chNewLine
	db	"3. Run Paused"
	db	chNewLine
	db	"4. About"
	db	chNewLine
	db	"5. Quit"
	db	chNewLine
	db	0
	db	sk1
; DW   mOptions-1
	word	DoSettings
	db	sk2
	word	PTSMain
	db	sk3
	word	PTPaused
	db	sk4
	word	menuAbout - 1
	db	sk5
	word	Quit
	db	skClear
	word	Quit
	db	0
menuAbout:
	db	"Photographic"
	db	chNewLine
	db	"Long Exposure & "
	db	"Time-Lasp Timer "
	db	"by Dr. D'nar"
	db	chNewLine
; DB   "rev. November 15"
	db	"Revision:"
	db	chNewLine
	db	"21 November 2011"
	db	0
	db	skClear
	word	menuMain - 1
	db	0
mOptions:
	db	"Options:"
	db	chNewLine
	db	"1. Times"
	db	chNewLine
	db	"2. Link/Conf"
	db	0
	db	sk1
	word	EditTimes
	db	sk2
	word	EditSettings
	db	skClear
	word	menuMain - 1
	db	0
;#SECTION "GetCSC", CODE

GetCloneSC:
	ld	c, 0BFh
	ld	b, 7
@:
	ld	a, c
	out	(1), a
	nop
	nop
	nop
	rrca
	ld	c, a
	in	a, (1)
	cp	0FFh
	jq	nz, @F
	djnz	@B
	ld	a, (lastKeyDelay)
	or	a
	ld	a, 0
	ret	nz
	ld	(lastKey), a
@:
	dec	b
	ld	c, b
	call	getResetBit
	ld	a, b
	sla	c
	sla	c
	sla	c
	add	a, c
	ld	b, a
	ld	a, (lastKey)
	ld	c, a
	ld	a, b
	cp	c
	ld	(lastKey), a
	jq	nz, @F
	xor	a
	ret

@:
	ld	a, keyDelay
	xor	a
	ld	(lastKeyDelay), a
	ld	a, (lastKey)
	ret

getResetBit:
	cp	0FFh
	ret	z
	ld	b, 0
@:
	rrca
	inc	b
	jq	c, @B
	ret

;#SECTION "DirectIn", CODE

DirectInput:
	out	(1), a
	push	hl
	pop	hl
	in	a, (1)
	cpl
	and	c
	ret

;#SECTION "StrRout", CODE

StrCopy:
	ld	a, (hl)
	or	a
	ret	z
	ld	(de), a
	inc	de
	inc	hl
	jr	StrCopy

;#SECTION "Data", DATA

; DB   $80,0,0,0,0
; FP256:
; DB   0,$82,$25,$60
; DB   0,0,0,0,0
timeBig:
	db	0, 80h, 96h, 98h
timeTiny:
	db	1
time0:
	db	0
timeNever:
; timeBig:
	db	0, 0, 0, 255
KAInt:
	db	128, 0, 0, 0
; strDone:
; DB   "           Done!"
; DB   chNewLine
; DB   0
strTime:
	db	"Time: ", 0
strNext:
	db	"Next: ", 0
strExpRemain:
	db	"Exp Left: ", 0
strExp:
	db	"ExpT: ", 0
strFocus:
	db	"Focus "
	db	chNormal
	db	0
strExpose:
	db	"Expose ", 0
strDeadlineMissed:
	db	"DLM! ", 0
evTableDefaults:
	word	0, 0, PTKAStart
	word	0, 0, PTKAStop
	word	0, 0, PTFCStart
	word	0, 0, PTFCStop
	word	0, 0, PTExpStart
	word	0, 0, PTExpStop
evTableDefaultsEnd:
evTableDefaultLen equ	evTableDefaultsEnd - evTableDefaults
defaultIntervals:
	db	0, 3, 0, 0
	db	0, 10, 0, 0
	db	0, 5, 0, 0
	db	128, 0, 0, 0
	db	0, 1, 0, 0
	db	0C0h, 0, 0, 0
	db	0, 100, 0, 0
defaultIntervalsEnd:
defaultIntervalsLen equ	defaultIntervalsEnd - defaultIntervals
;#IMPORT "ptmenu"
;#IMPORT "PTOPTS"
;#IMPORT "ptnum"
;#IMPORT "ptname"
;#IMPORT "Flash.h"
