;#SECTION "MAIN", CODE

; input:
; -hl: number
; -de: ptr to loc to write str
Num2Dec:
	ld	bc, -10000
	call	num1
	ld	bc, -1000
	call	num1
	ld	bc, -100
	call	num1
	ld	bc, -10
	call	num1
	ld	c, b
num1:
	ld	a, '0' - 1
num2:
	inc	a
	add	hl, bc
	jr	c, num2
	sbc	hl, bc
	ld	(de), a
	inc	de
	xor	a
	ld	(de), a
	ret

;#SECTION "Num2Hex", CODE

; IFDEF NUM_HEX
; input:
; hl: number
; de: ptr to str
Num2Hex:
	ld	a, h
	call	HexNum1
	ld	a, h
	call	HexNum2
ShortNum2Hex:
	ld	a, l
	call	HexNum1
	ld	a, l
	jr	HexNum2

HexNum1:
	rra
	rra
	rra
	rra
HexNum2:
	or	0F0h
	daa
	add	a, 0A0h
	adc	a, 40h
	ld	(de), a
	inc	de
	ret

; ENDIF
;#SECTION "DivHl-C", CODE

DivHLByC:
	xor	a
	ld	b, 16
@:
	add	hl, hl
	rla
	cp	c
	jr	c, $ + 4
	sub	c
	inc	l
	djnz	@B
	ret

;#SECTION "AToI", CODE

	ifdef	ATOI
AToI:
; ASCII to int16
; input:
; DE: ASCII-Z string
; output:
; HL: int
; any non-numeral char
; ends decoding
	ld	hl, 0
.atoiloop:
	ld	c, l
	ld	b, h
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	a, (de)
	or	a
	ret	z
	sub	30h
	ret	c
	cp	10
	jq	nc, .atoiloop
	ret

	endif
;#SECTION "MultHByE", CODE

MultHByE:
; Output:
; -HL
	xor	a
	ld	l, a
	ld	d, a
	sla	h
	jr	nc, $ + 3
	ld	l, e
	ld	b, 7
@:
	add	hl, hl
	jr	nc, $ + 3
	add	hl, de
	djnz	@B
	ret

;#SECTION "Div24-8", CODE

	ifdef	NEVER
DivEHLByD:
	xor	a
	ld	b, 24
@:
	add	hl, hl
	rl	e
	rla
	cp	d
	jr	c, $ + 4
	sub	d
	inc	l
	djnz	@B
	ret

	endif
;#SECTION "Div32-8", CODE

	ifdef	DIV_32
DivDEHLByC:
	xor	a
	ld	b, 32
@:
	add	hl, hl
	rl	e
	rl	d
	rla
	cp	c
	jr	c, $ + 4
	sub	c
	inc	l
	djnz	@B
	ret

	endif
;#SECTION "Str24", CODE

	ifdef	NEVER
; Str24:
; Input:
; EHL: #
; IX: Dest
	ld	c, 8
@:
	ld	d, 10
	call	DivEHLByD
	push	af
	dec	c
	jr	nz, @B
	ld	b, 8
@:
	pop	af
	cp	10
	jr	c, $ + 3
	sub	a
	add	a, 30h
	ld	(ix + 0), a
	inc	ix
	djnz	@B
	ret

	endif
;#SECTION "Str24-2", CODE

Str24:
; .s24temp = asm_Flag3
	ld	a, e
; LD   C,$67
; LD   DE,$6980
; CALL .divf
	ld	c, 0F0h
	ld	de, 0BDC0h
	call	.divf
	ld	c, 0FEh
	ld	de, 7960h
	call	.divf
; INC  C
	ld	c, 0FFh
	ld	de, 0D8F0h
	call	.divf
; LD   C,$FF
	ld	de, 0FC18h
	call	.div
	ld	de, 0FF9Ch
	call	.div
	ld	e, 0F6h
	call	.div
	ld	e, d
.div:
	ld	b, 2Fh
@:
	inc	b
	add	hl, de
	jr	c, @B
	sbc	hl, de
	ld	(ix + 0), b
	inc	ix
	ld	(ix + 0), 0
	ret

.divf:
	ld	b, 2Fh
@:
	inc	b
	add	hl, de
	adc	a, c
	jr	c, @B
	sbc	hl, de
	sbc	a, c
	ld	c, a
	ld	a, b
	cp	3Ah
	jr	c, @F
	add	a, 7
	ld	b, a
@:
	ld	a, c
	ld	(ix + 0), b
	inc	ix
	ld	(ix + 0), 0
	ret

